//	app.h - Main application stuff.
//	----------------------------------------------------------------------------
//	This file is part of Motion Composition Tool, a simple application for
//	creating simple abstract animations.
//	Copyright (c) 2007 Niall Moody.
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//	----------------------------------------------------------------------------

#ifndef APP_H_
#define APP_H_

///	Handles the main application stuff.
class App : public JUCEApplication,
				   ButtonListener
{
  public:
	///	Constructor.
	App() {win = 0;};
	///	Destructor.
	~App() {};

	///	Where all the important stuff happens for this class.
	void initialise(const String& commandLine);
	///	Not used by us?
	void shutdown();

	///	Called when the DialogWindow's close button is pressed.
	void buttonClicked(Button *button);

	///	Returns the name of the application (duh...).
	const String getApplicationName() {return T("Motion Composition Tool");};
	///	Returns the current version.
	const String getApplicationVersion() {return T("0.10");};
	///	Whether or not we want to allow more than one instance to run.
	bool moreThanOneInstanceAllowed() {return true;};
	///	Not used right now?
	void anotherInstanceStarted(const String& commandLine) {};

	///	Returns the main window.
	DocumentWindow *getWindow() {return win;};
  private:
	///	Pointer to our main window.
	DocumentWindow *win;
	///	Because we want to use the shiny look and feel.
	ShinyLookAndFeel *shiny;

	///	ApplicationCommandManager.
	ApplicationCommandManager *commands;
};

#endif
